# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::KeyVault::V2016_10_01
  module Models
    #
    # A SAS definition bundle consists of key vault SAS definition details plus
    # its attributes.
    #
    class SasDefinitionBundle

      include MsRestAzure

      # @return [String] The SAS definition id.
      attr_accessor :id

      # @return [String] Storage account SAS definition secret id.
      attr_accessor :secret_id

      # @return [Hash{String => String}] The SAS definition metadata in the
      # form of key-value pairs.
      attr_accessor :parameters

      # @return [SasDefinitionAttributes] The SAS definition attributes.
      attr_accessor :attributes

      # @return [Hash{String => String}] Application specific metadata in the
      # form of key-value pairs
      attr_accessor :tags


      #
      # Mapper for SasDefinitionBundle class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'SasDefinitionBundle',
          type: {
            name: 'Composite',
            class_name: 'SasDefinitionBundle',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              secret_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'sid',
                type: {
                  name: 'String'
                }
              },
              parameters: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'parameters',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              attributes: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'attributes',
                type: {
                  name: 'Composite',
                  class_name: 'SasDefinitionAttributes'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
