# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::KeyVault::V7_0_preview
  module Models
    #
    # Properties of the X509 component of a certificate.
    #
    class X509CertificateProperties

      include MsRestAzure

      # @return [String] The subject name. Should be a valid X509 distinguished
      # Name.
      attr_accessor :subject

      # @return [Array<String>] The enhanced key usage.
      attr_accessor :ekus

      # @return [SubjectAlternativeNames] The subject alternative names.
      attr_accessor :subject_alternative_names

      # @return [Array<KeyUsageType>] List of key usages.
      attr_accessor :key_usage

      # @return [Integer] The duration that the certificate is valid in months.
      attr_accessor :validity_in_months


      #
      # Mapper for X509CertificateProperties class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'X509CertificateProperties',
          type: {
            name: 'Composite',
            class_name: 'X509CertificateProperties',
            model_properties: {
              subject: {
                client_side_validation: true,
                required: false,
                serialized_name: 'subject',
                type: {
                  name: 'String'
                }
              },
              ekus: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ekus',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              subject_alternative_names: {
                client_side_validation: true,
                required: false,
                serialized_name: 'sans',
                type: {
                  name: 'Composite',
                  class_name: 'SubjectAlternativeNames'
                }
              },
              key_usage: {
                client_side_validation: true,
                required: false,
                serialized_name: 'key_usage',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'KeyUsageTypeElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              validity_in_months: {
                client_side_validation: true,
                required: false,
                serialized_name: 'validity_months',
                constraints: {
                  InclusiveMinimum: 0
                },
                type: {
                  name: 'Number'
                }
              }
            }
          }
        }
      end
    end
  end
end
