# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::KeyVault::V7_0
  module Models
    #
    # A deleted SAS definition bundle consisting of its previous id, attributes
    # and its tags, as well as information on when it will be purged.
    #
    class DeletedSasDefinitionBundle < SasDefinitionBundle

      include MsRestAzure

      # @return [String] The url of the recovery object, used to identify and
      # recover the deleted SAS definition.
      attr_accessor :recovery_id

      # @return The time when the SAS definition is scheduled to be purged, in
      # UTC
      attr_accessor :scheduled_purge_date

      # @return The time when the SAS definition was deleted, in UTC
      attr_accessor :deleted_date


      #
      # Mapper for DeletedSasDefinitionBundle class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'DeletedSasDefinitionBundle',
          type: {
            name: 'Composite',
            class_name: 'DeletedSasDefinitionBundle',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              secret_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'sid',
                type: {
                  name: 'String'
                }
              },
              template_uri: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'templateUri',
                type: {
                  name: 'String'
                }
              },
              sas_type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'sasType',
                type: {
                  name: 'String'
                }
              },
              validity_period: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'validityPeriod',
                type: {
                  name: 'String'
                }
              },
              attributes: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'attributes',
                type: {
                  name: 'Composite',
                  class_name: 'SasDefinitionAttributes'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              recovery_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'recoveryId',
                type: {
                  name: 'String'
                }
              },
              scheduled_purge_date: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'scheduledPurgeDate',
                type: {
                  name: 'UnixTime'
                }
              },
              deleted_date: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'deletedDate',
                type: {
                  name: 'UnixTime'
                }
              }
            }
          }
        }
      end
    end
  end
end
