# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::KeyVault::V7_1
  module Models
    #
    # A Deleted Certificate consisting of its previous id, attributes and its
    # tags, as well as information on when it will be purged.
    #
    class DeletedCertificateBundle < CertificateBundle

      include MsRestAzure

      # @return [String] The url of the recovery object, used to identify and
      # recover the deleted certificate.
      attr_accessor :recovery_id

      # @return The time when the certificate is scheduled to be purged, in UTC
      attr_accessor :scheduled_purge_date

      # @return The time when the certificate was deleted, in UTC
      attr_accessor :deleted_date


      #
      # Mapper for DeletedCertificateBundle class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'DeletedCertificateBundle',
          type: {
            name: 'Composite',
            class_name: 'DeletedCertificateBundle',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              kid: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'kid',
                type: {
                  name: 'String'
                }
              },
              sid: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'sid',
                type: {
                  name: 'String'
                }
              },
              x509thumbprint: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'x5t',
                type: {
                  name: 'Base64Url'
                }
              },
              policy: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'policy',
                type: {
                  name: 'Composite',
                  class_name: 'CertificatePolicy'
                }
              },
              cer: {
                client_side_validation: true,
                required: false,
                serialized_name: 'cer',
                type: {
                  name: 'ByteArray'
                }
              },
              content_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'contentType',
                type: {
                  name: 'String'
                }
              },
              attributes: {
                client_side_validation: true,
                required: false,
                serialized_name: 'attributes',
                type: {
                  name: 'Composite',
                  class_name: 'CertificateAttributes'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              recovery_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'recoveryId',
                type: {
                  name: 'String'
                }
              },
              scheduled_purge_date: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'scheduledPurgeDate',
                type: {
                  name: 'UnixTime'
                }
              },
              deleted_date: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'deletedDate',
                type: {
                  name: 'UnixTime'
                }
              }
            }
          }
        }
      end
    end
  end
end
