# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::KeyVault::V7_1
  module Models
    #
    # The deleted SAS definition list result
    #
    class DeletedSasDefinitionListResult

      include MsRestAzure

      include MsRest::JSONable
      # @return [Array<DeletedSasDefinitionItem>] A response message containing
      # a list of the deleted SAS definitions in the vault along with a link to
      # the next page of deleted sas definitions
      attr_accessor :value

      # @return [String] The URL to get the next set of deleted SAS
      # definitions.
      attr_accessor :next_link

      # return [Proc] with next page method call.
      attr_accessor :next_method

      #
      # Gets the rest of the items for the request, enabling auto-pagination.
      #
      # @return [Array<DeletedSasDefinitionItem>] operation results.
      #
      def get_all_items
        items = @value
        page = self
        while page.next_link != nil && !page.next_link.strip.empty? do
          page = page.get_next_page
          items.concat(page.value)
        end
        items
      end

      #
      # Gets the next page of results.
      #
      # @return [DeletedSasDefinitionListResult] with next page content.
      #
      def get_next_page
        response = @next_method.call(@next_link).value! unless @next_method.nil?
        unless response.nil?
          @next_link = response.body.next_link
          @value = response.body.value
          self
        end
      end

      #
      # Mapper for DeletedSasDefinitionListResult class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'DeletedSasDefinitionListResult',
          type: {
            name: 'Composite',
            class_name: 'DeletedSasDefinitionListResult',
            model_properties: {
              value: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'value',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'DeletedSasDefinitionItemElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'DeletedSasDefinitionItem'
                      }
                  }
                }
              },
              next_link: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'nextLink',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
