# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::KeyVault::V7_1
  module Models
    #
    # The issuer for Key Vault certificate.
    #
    class IssuerBundle

      include MsRestAzure

      # @return [String] Identifier for the issuer object.
      attr_accessor :id

      # @return [String] The issuer provider.
      attr_accessor :provider

      # @return [IssuerCredentials] The credentials to be used for the issuer.
      attr_accessor :credentials

      # @return [OrganizationDetails] Details of the organization as provided
      # to the issuer.
      attr_accessor :organization_details

      # @return [IssuerAttributes] Attributes of the issuer object.
      attr_accessor :attributes


      #
      # Mapper for IssuerBundle class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'IssuerBundle',
          type: {
            name: 'Composite',
            class_name: 'IssuerBundle',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              provider: {
                client_side_validation: true,
                required: false,
                serialized_name: 'provider',
                type: {
                  name: 'String'
                }
              },
              credentials: {
                client_side_validation: true,
                required: false,
                serialized_name: 'credentials',
                type: {
                  name: 'Composite',
                  class_name: 'IssuerCredentials'
                }
              },
              organization_details: {
                client_side_validation: true,
                required: false,
                serialized_name: 'org_details',
                type: {
                  name: 'Composite',
                  class_name: 'OrganizationDetails'
                }
              },
              attributes: {
                client_side_validation: true,
                required: false,
                serialized_name: 'attributes',
                type: {
                  name: 'Composite',
                  class_name: 'IssuerAttributes'
                }
              }
            }
          }
        }
      end
    end
  end
end
