# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::KeyVault::V7_2_preview
  module Models
    #
    # The key operations parameters.
    #
    class KeyOperationsParameters

      include MsRestAzure

      # @return [JsonWebKeyEncryptionAlgorithm] algorithm identifier. Possible
      # values include: 'RSA-OAEP', 'RSA-OAEP-256', 'RSA1_5', 'A128GCM',
      # 'A192GCM', 'A256GCM', 'A128KW', 'A192KW', 'A256KW', 'A128CBC',
      # 'A192CBC', 'A256CBC', 'A128CBCPAD', 'A192CBCPAD', 'A256CBCPAD'
      attr_accessor :algorithm

      # @return
      attr_accessor :value

      # @return Initialization vector for symmetric algorithms.
      attr_accessor :iv

      # @return Additional data to authenticate but not encrypt/decrypt when
      # using authenticated crypto algorithms.
      attr_accessor :aad

      # @return The tag to authenticate when performing decryption with an
      # authenticated algorithm.
      attr_accessor :tag


      #
      # Mapper for KeyOperationsParameters class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'KeyOperationsParameters',
          type: {
            name: 'Composite',
            class_name: 'KeyOperationsParameters',
            model_properties: {
              algorithm: {
                client_side_validation: true,
                required: true,
                serialized_name: 'alg',
                constraints: {
                  MinLength: 1
                },
                type: {
                  name: 'String'
                }
              },
              value: {
                client_side_validation: true,
                required: true,
                serialized_name: 'value',
                type: {
                  name: 'Base64Url'
                }
              },
              iv: {
                client_side_validation: true,
                required: false,
                serialized_name: 'iv',
                type: {
                  name: 'Base64Url'
                }
              },
              aad: {
                client_side_validation: true,
                required: false,
                serialized_name: 'aad',
                type: {
                  name: 'Base64Url'
                }
              },
              tag: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tag',
                type: {
                  name: 'Base64Url'
                }
              }
            }
          }
        }
      end
    end
  end
end
