# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::KeyVault::V7_2_preview
  module Models
    #
    # A Storage account bundle consists of key vault storage account details
    # plus its attributes.
    #
    class StorageBundle

      include MsRestAzure

      # @return [String] The storage account id.
      attr_accessor :id

      # @return [String] The storage account resource id.
      attr_accessor :resource_id

      # @return [String] The current active storage account key name.
      attr_accessor :active_key_name

      # @return [Boolean] whether keyvault should manage the storage account
      # for the user.
      attr_accessor :auto_regenerate_key

      # @return [String] The key regeneration time duration specified in
      # ISO-8601 format.
      attr_accessor :regeneration_period

      # @return [StorageAccountAttributes] The storage account attributes.
      attr_accessor :attributes

      # @return [Hash{String => String}] Application specific metadata in the
      # form of key-value pairs
      attr_accessor :tags


      #
      # Mapper for StorageBundle class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'StorageBundle',
          type: {
            name: 'Composite',
            class_name: 'StorageBundle',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              resource_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'resourceId',
                type: {
                  name: 'String'
                }
              },
              active_key_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'activeKeyName',
                type: {
                  name: 'String'
                }
              },
              auto_regenerate_key: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'autoRegenerateKey',
                type: {
                  name: 'Boolean'
                }
              },
              regeneration_period: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'regenerationPeriod',
                type: {
                  name: 'String'
                }
              },
              attributes: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'attributes',
                type: {
                  name: 'Composite',
                  class_name: 'StorageAccountAttributes'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
